package bz393 
{
	import bz393.event.JsonEvent;
	import com.adobe.serialization.json.JSON;
	import flash.errors.IOError;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	
	/**
	 * ...
	 * @author 393
	 */
	public class JsonLoader extends EventDispatcher 
	{
		static public const OPEN:String = "open";
		static public const CLOSE:String = "close";
		static public const IO_ERROR:String = "ioError";
		
		private static var instance:JsonLoader;
		
		private var _jsonUrl:String = "http://score393.appspot.com/json";
		private var _addUrl:String = "http://score393.appspot.com/addScore";
		private var _get_urlLoader:URLLoader;
		private var _add_urlLoader:URLLoader;
		private var _urlVariables:URLVariables;
		
		public function JsonLoader(enforcer:SingletonEnforcer) { };
		
		public static function getInstance():JsonLoader {
			if (!JsonLoader.instance) {
				JsonLoader.instance = new JsonLoader(new SingletonEnforcer());
				
			}
			return JsonLoader.instance;
		}
		public function init():void
		{
			//初期化
			_get_urlLoader = new URLLoader();
			_get_urlLoader.addEventListener(Event.COMPLETE, urlLoader_completeHandler);
			_get_urlLoader.addEventListener(IOErrorEvent.IO_ERROR, get_ioErrorHandler);
			
			_add_urlLoader = new URLLoader();
			_add_urlLoader.addEventListener(Event.COMPLETE, urlLoader_addCompleteHandler);
			_add_urlLoader.addEventListener(IOErrorEvent.IO_ERROR, add_ioErrorHandler);
		}
		
		public function getJson():void
		{
			_get_urlLoader.load(new URLRequest(_jsonUrl + "?hoge=" + int(Math.random() * 10000)));
			
			this.dispatchEvent(new Event(JsonLoader.OPEN));
		}
		
		
		private function get_ioErrorHandler(e:IOErrorEvent):void 
		{
			trace("IO_ERROR : " + e);
			getJson();
			
			//this.dispatchEvent(new Event(JsonLoader.IO_ERROR));
		}
		private function add_ioErrorHandler(e:IOErrorEvent):void 
		{
			trace("IO_ERROR : " + e);
			reAddScore();
			//this.dispatchEvent(new Event(JsonLoader.IO_ERROR));
		}
		
		private function urlLoader_completeHandler(e:Event):void 
		{
			var json:String = e.target.data;
			var jsonArray:Array = JSON.decode(json);
			
			dispatchEvent(new JsonEvent(JsonEvent.LOAD_COMPLETE, jsonArray));
			dispatchEvent(new Event(JsonLoader.CLOSE));
		}
		public function addScore(info:Object):void
		{
			trace("OPEN : ");
			var urlReauest:URLRequest = new URLRequest(_addUrl + "?hoge="+int(Math.random()*10000));
			urlReauest.method = URLRequestMethod.POST;
			
			_urlVariables = new URLVariables();
			_urlVariables.id = info.id;
			_urlVariables.score = info.score;
			
			urlReauest.data = _urlVariables;
			_add_urlLoader.load(urlReauest);
			
			this.dispatchEvent(new Event(JsonLoader.OPEN));
		}
		public function reAddScore():void
		{
			var urlReauest:URLRequest = new URLRequest(_addUrl + "?hoge="+int(Math.random()*10000));
			urlReauest.method = URLRequestMethod.POST;
			urlReauest.data = _urlVariables;
			_add_urlLoader.load(urlReauest);
			
			this.dispatchEvent(new Event(JsonLoader.OPEN));
		}
		
		private function urlLoader_addCompleteHandler(e:Event):void 
		{
			var json:String = e.target.data;
			var jsonArray:Array = JSON.decode(json);
			
			dispatchEvent(new JsonEvent(JsonEvent.ADD_COMPLETE, jsonArray));
			dispatchEvent(new Event(JsonLoader.CLOSE));
		}
	}
}

class SingletonEnforcer {};