package bz393
{
	import bz393.event.JsonEvent;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.events.*;
	import flash.utils.Timer;
	
	/**
	 * ...
	 * @author 393
	 */
	public class Main extends Sprite 
	{
		
		//玉の速度(固定)
		private var bulletSpeed:int = 20;
		//的の速度(可変)
		private var enemySpeed:int;
		//得点の管理
		private var score:int = 0;
		//敵の方向（左ならtrue)
		private var isLeft:Boolean = true;
		//敵の移動方向を反転管理
		//ここには[1]か、[-1]かの値を入れる
		private var unit:int = 1;
		//敵の縦方向の位置を管理
		//0:で一番上、
		private var yCount:int = 0;
		//敵の縦方向の移動量（固定）
		private var offsetY:int = 80;
		
		private var addPoint:int = 0;
		private var defaultAddPoint:int = 100;
		
		private var offsetSpeed:int = 5;
		
		private var _result:Array = [];
		private var _plate:MovieClip;
		
		private var _scoreBoard:ScoreBoard;
		private var _jsonArray:Array;
		
		private var w:int = 400;
		private var h:int = 600;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			//stage.align = "left";
			//stage.scaleMode = StageScaleMode.NO_SCALE;
			
			//初期化
			JsonLoader.getInstance().init();
			
			offsetY = enemy_mc.height;
			
			_scoreBoard = new ScoreBoard(this);
			addChild(_scoreBoard).visible = false;
			
			var loadingBoard:LoadingBoard = new LoadingBoard();
			addChild(loadingBoard);
			
			JsonLoader.getInstance().addEventListener(JsonEvent.LOAD_COMPLETE, jsonLoader_loadComplete);
			JsonLoader.getInstance().addEventListener(JsonEvent.ADD_COMPLETE, jsonLoader_loadComplete);
			
			JsonLoader.getInstance().getJson();
		}
		
		public function jsonLoader_loadComplete(e:JsonEvent):void 
		{
			JsonLoader.getInstance().removeEventListener(JsonEvent.LOAD_COMPLETE, jsonLoader_loadComplete);	
			//配列にセット
			_jsonArray = e.info;
			trace("_jsonArray : " + _jsonArray);
			
			//ハイスコアのセット
			if (_jsonArray.length) highScore_txt.text = _jsonArray[0].score.toString();
			else highScore_txt.text = "0";
			
			reset();
		}
		
		public function reset():void 
		{
			// entry point
			//敵を一番上に
			yCount = 0;
			//得点を0に
			score = 0;
			//得点をテキストフィールドに反映
			score_txt.text = String(score);
			//自機のグラフィックを生存状態に
			player_mc.gotoAndStop(1);
			
			offsetSpeed = 5;
			bulletSpeed = 20;
			
			addPoint = defaultAddPoint;
			
			//敵の初期化
			setEnemy();
			//ステージクリックで玉発射
			stage.addEventListener(MouseEvent.CLICK, stageClickHandler);
			//エネミーを動かすエンターフレーム処理
			enemy_mc.addEventListener(Event.ENTER_FRAME, enemy_enterFrameHandler);
		}

		//敵キャラの初期化
		function setEnemy():void
		{
			//敵の速度を乱数で設定：5～20の値となる
			enemySpeed = (Math.random() * 10 + offsetSpeed);
			
			//でてくる方向
			if( unit < 0)
			{
				isLeft = true;
				unit = 1;
				//敵の初期位置を設定 ぎりぎり見えない位置～ -400
				enemy_mc.x = -Math.random()*(400*Math.abs(enemySpeed)*.2) - enemy_mc.width/2;
			}
			else
			{
				isLeft = false;
				unit = -1;
				//敵の初期位置を設定 ぎりぎり見えない位置～ -400
				enemy_mc.x = Math.random()*(400*Math.abs(enemySpeed)*.2) + enemy_mc.width/2 + w;
			}
			//敵の縦方向の位置を計算
			//yCountの値に応じて、80 → 160 → 240 ･･･といった具合に増える
			enemy_mc.y = offsetY*yCount + offsetY;
			enemySpeed *= unit;
			
			//敵のグラフィックアニメーションを開始
			enemy_mc.gotoAndPlay(1);
		}


		function enemy_enterFrameHandler (e:Event):void
		{
			//敵の移動
			enemy_mc.x += enemySpeed;
			
			//プレイヤーと敵が接触したらゲームオーバー
			if ( enemy_mc.hitTestObject(player_mc)) 
			{
				//自機のグラフィックを破壊状態にする
				player_mc.gotoAndStop(2);
				//ステージクリックで玉発射のイベントを破棄
				stage.removeEventListener(MouseEvent.CLICK, stageClickHandler);
				//エネミーを動かすエンターフレーム処理を破棄
				enemy_mc.removeEventListener(Event.ENTER_FRAME, enemy_enterFrameHandler);
				//ステージクリックでリセット処理のイベントを設定
				//stage.addEventListener(MouseEvent.CLICK, resetHandler);
				
				stage.removeEventListener(MouseEvent.CLICK, stageClickHandler);
				//ハイスコアのスコアのチェック
				gameOver();
			}
			
			//敵が画面の端に達したら（画面から見えなくなったら）
			if(isLeft && enemy_mc.x > w + enemy_mc.width/2
							|| !isLeft && enemy_mc.x < - enemy_mc.width/2)
			{
				//敵の縦方向の位置を一つカウントアップ
				yCount++;
				//得点ダウン
				addPoint *= 0.5;
				//敵の初期化
				setEnemy();
			}
		}
		
		private function gameOver():void 
		{
			//最新の状態を取得
			setJson(_jsonArray);
		}
		
		//getJson後の処理
		private function setJson(jsonArray:Array):void 
		{
			//スコアボードの表示
			_scoreBoard.visible = true;
			
			//0点ならスルー
			if (! score)
			{
				_scoreBoard.setList(jsonArray,3000);
				return;
			}
			
			var length:int = jsonArray.length;
			if (length > 10) length = 10;
			for (var i:int = 0; i < length; i++)
			{
				if (score > jsonArray[i].score)
				{
					jsonArray.splice(i, 0, { "id":"", "score":score } );
					_scoreBoard.setListChange(jsonArray,i);
					setScore(score);
					return;
				}
			}
			
			if (length < 9)
			{
				jsonArray.splice(i, 0, { "id":"", "score":score });
				_scoreBoard.setListChange(jsonArray,i);
				setScore(score);
				return;
			}
			else 
			{
				_scoreBoard.setList(jsonArray,3000);
			}
		}
		
		private function setScore(currentScore:int):void 
		{
			dispatchEvent(new DataEvent("enterInitial",false,false,String(currentScore)));
		}
		
		//ステージクリックで玉発射のイベント処理
		function stageClickHandler (e:MouseEvent):void
		{
			//玉の初期座標を決める
			bullet_mc.x = player_mc.x;
			bullet_mc.y = player_mc.y;
			//玉を表示状態に
			bullet_mc.visible = true;
			//玉のエンターフレーム処理を追加
			bullet_mc.addEventListener(Event.ENTER_FRAME, bullet_enterFrameHandler);
			//ステージクリック処理を削除
			stage.removeEventListener(MouseEvent.CLICK, stageClickHandler);
		}

		//玉のエンターフレーム処理
		function bullet_enterFrameHandler (e:Event):void
		{
			//玉のY座標を更新
			bullet_mc.y -= bulletSpeed;
			//もし敵が撃墜状態なら当たり判定の処理は行わないで処理終了
			if(enemy_mc.currentFrame == 31) return;
			
			//アタリ判定の確認
			if(bullet_mc.hitTestObject(enemy_mc))
			{
				//敵の縦方向位置を初期化(0でなく-1とする理由は95行目でのyCount++;を考慮して)
				yCount = -1;

				//敵のグラフィックを破壊状態に
				enemy_mc.gotoAndStop("break");
				//玉を非表示に
				bullet_mc.visible = false;
				//得点を100点プラス
				score += addPoint;
				//得点をテキストフィールドに反映
				score_txt.text = String(score);
				
				addPoint = defaultAddPoint * 2;
				
				if (offsetSpeed < 20)
				{
					offsetSpeed += 2;
					bulletSpeed += 2;
					//enemy_mc.scaleX *= 0.9;
					//enemy_mc.scaleY *= 0.9;
				}
			}
			//もし玉が、画面上部から見えなくなったら、
			if( e.target.y < 0 - e.target.height)
			{
				//ステージクリックイベント追加
				stage.addEventListener(MouseEvent.CLICK, stageClickHandler);
				//玉に関するエンターフレーム処理の停止
				bullet_mc.removeEventListener(Event.ENTER_FRAME, bullet_enterFrameHandler);
			}
		}
	
	}
}