package bz393 
{
	import bz393.event.JsonEvent;
	import bz393.Main;
	import fl.managers.FocusManager;
	import flash.display.MovieClip;
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.utils.Timer;
	
	/**
	 * ...
	 * @author 393
	 */
	public class ScoreBoard extends MovieClip 
	{
		private var _scoreArray:/*TextField*/Array;
		private var _nameArray:/*TextField*/Array;
		private var _titleArray:/*TextField*/Array;
		
		private var _currentNameTf:TextField;
		private var _currentScoreTf:TextField;
		private var _main:Main;
		private var _enterInitialContainer:MovieClip;
		private var _focusManager:FocusManager;
		private var _currentIndex:int;
		private var _currentData:Object;
		
		public function ScoreBoard(main:Main ) 
		{
			_main = main;
			if (stage) init(null);
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public function setListChange(jsonArray:Array,index:int):void 
		{
			var length:int = jsonArray.length;
			if (length > 10) length = 10;
			for (var i:int = 0; i < length; i++)
			{
				_nameArray[i].text = jsonArray[i].id;
				_scoreArray[i].text = jsonArray[i].score.toString();
				if (i == index)
				{
					_nameArray[i].textColor = 0xFFFF00;
					_scoreArray[i].textColor = 0xFFFF00;
					_titleArray[i].textColor = 0xFFFF00;
					_currentData = { "id":jsonArray[i].id, "score":jsonArray[i].score };
					trace("★_currentData : " + _currentData.id);
				}
				else
				{
					_nameArray[i].textColor = 0x00FFFF;
					_scoreArray[i].textColor = 0x00FFFF;
					_titleArray[i].textColor = 0x00FFFF;
				}
				
			}
			for ( i = length; i < 10; i++)
			{
				_scoreArray[i].text = "-";
				_nameArray[i].text = "---";
			}
			_currentIndex = index;
		}
		public function setList(jsonArray:Array,delayTime:int = 1000):void 
		{
			trace("★ScoreBoard.setList > jsonArray : ");
			_enterInitialContainer.visible = false;
			
			var length:int = jsonArray.length;
			if (length > 10) length = 10;
			
			for (var i:int = 0; i < length; i++)
			{
				_nameArray[i].text = jsonArray[i].id;
				_scoreArray[i].text = jsonArray[i].score.toString();
				_nameArray[i].textColor = 0x00FFFF;
				_scoreArray[i].textColor = 0x00FFFF;
				_titleArray[i].textColor = 0x00FFFF;
			}
			for ( i = length; i < 10; i++)
			{
				_scoreArray[i].text = "-";
				_nameArray[i].text = "---";
			}
			//時差
			var timer:Timer = new Timer(delayTime, 1);
			timer.addEventListener(TimerEvent.TIMER, timerHandler);
			timer.start();
		}
		
		
		private function init(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			_focusManager = new FocusManager(this);
			
			_main.addEventListener("enterInitial", enterInitialHandler);
			setInstance();
		}
		
		
		private function enterInitialHandler(e:DataEvent):void 
		{
			_enterInitialContainer.visible = true;
			//カーソルをフォーカスにセット
			_currentNameTf.selectable = true;
			_focusManager.setFocus(_currentNameTf);
			
			_currentScoreTf.text = e.data;
			_currentNameTf.text = "";
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
		}
		//エンターキーを押したときの処理
		private function keyDownHandler(e:KeyboardEvent):void 
		{
			if (e.keyCode != 13) return;
			trace("エンターキーダウン");
			
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			
			//登録
			_nameArray[_currentIndex].text = _currentNameTf.text;
			_focusManager.setFocus(stage);
			_currentNameTf.selectable = false;
			
			//非表示に
			this.visible = false;
			
			_currentData.id = _currentNameTf.text;
			JsonLoader.getInstance().addScore(_currentData);
		}
		
		private function timerHandler(e:TimerEvent):void 
		{
			trace("タイマー処理");
			e.target.removeEventListener(TimerEvent.TIMER, timerHandler);
			this.visible = false;
			Main(parent).reset();
		}
		
		private function setInstance():void 
		{
			_scoreArray = [];
			_nameArray = [];
			_titleArray = [];
			
			for (var i:int = 0; i < 10; i++)
			{
				_scoreArray[i] = this["s" + i];
				_nameArray[i] = this["n" + i];
				_titleArray[i] = this["t" + i];
			}
			
			_enterInitialContainer = enterInitialContainer;
			_enterInitialContainer.visible = false;
			
			_currentNameTf = enterInitialContainer.nc;
			_currentScoreTf = enterInitialContainer.sc;
			_currentNameTf.restrict = "a-zA-z0-9_.!#$%&'()-=^<>/"
			_currentNameTf.maxChars = 3;
			_currentNameTf.text = "";
		}
		
	}

}